<template lang="pug">
transition(@enter="onEnter" @leave="onLeave" css=false mode="out-in")
  slot(v-if="!loading")
  slot(v-else name="loader")
    .abs-top-center.text-center(key='loader' ref="loader")
      .fa.fa-spinner.fa-pulse
</template>

<script>
import _ from 'lodash'
import Anim from './BaseAnimation'

/*
 * CSS animations are easier to achieve in an inline-block that has no
 * margins/padding, which is what this components does
 */
export default {
  name: 'BaseAnimationLoader',
  props: {
    loading: Boolean,
    animIn: { type: String, default: 'defaultIn' },
    animOut: { type: String, default: 'defaultOut' }
  },
  methods: {
    onEnter(elt, done) {
      if (elt === this.$slots.loader || elt === this.$refs.loader) {
        Anim.fadeIn(elt, null, done);
      }
      else {
        _.invoke(Anim, this.$props.animIn, elt, this.options, done);
      }
    },
    onLeave(elt, done) {
      if (elt === this.$slots.loader || elt === this.$refs.loader) {
        Anim.fadeOut(elt, null, done);
      }
      else {
        _.invoke(Anim, this.$props.animOut, elt, this.options, done);
      }
    }
  }
}
</script>

<style>
</style>
